LLIST struct
	head	dword	?
	tail	dword	?
LLIST ends

LNODE struct
	next	dword	?
	prev	dword	?
	value	dword	?
LNODE ends

LITERATE struct
	_list	dword	?
	next	dword	?
	last	dword	?
LITERATE ends

.code
llCreate proc
	
	push sizeof LLIST
	push LMEM_FIXED
	call LocalAlloc
	
	mov (LLIST ptr [eax]).head, 0
	mov (LLIST ptr [eax]).tail, 0
	
	ret
	
llCreate endp

; returns a pointer to the element, can be used for removal
llAdd proc list:dword, value:dword
	push esi
	push edi
	
	mov esi, list
	mov edi, (LLIST ptr [esi]).tail
	
	test edi, edi
	jz _first
	
	fsAlloc %(sizeof LNODE)
	mov (LLIST ptr [esi]).tail, eax
	mov (LNODE ptr [eax]).next, 0
	mov (LNODE ptr [eax]).prev, edi
	mov (LNODE ptr [edi]).next, eax
	mov edx, value
	mov (LNODE ptr [eax]).value, edx
	
	pop edi
	pop esi
	ret
	
_first:
	fsAlloc %(sizeof LNODE)
	mov (LLIST ptr [esi]).head, eax
	mov (LLIST ptr [esi]).tail, eax
	mov (LNODE ptr [eax]).next, 0
	mov (LNODE ptr [eax]).prev, 0
	mov edx, value
	mov (LNODE ptr [eax]).value, edx
	
	pop edi
	pop esi
	ret
	
llAdd endp

llRemove proc list:dword, element:dword
	push esi
	push edi
	
	mov esi, list
	mov eax, element
	
	mov ecx, (LNODE ptr [eax]).next
	mov edx, (LNODE ptr [eax]).prev
	test ecx, ecx
	jz @F
	mov (LNODE ptr [ecx]).prev, edx
@@:
	test edx, edx
	jz @F
	mov (LNODE ptr [edx]).next, ecx
@@:
	cmp eax, (LLIST ptr [esi]).head
	jnz @F
	mov (LLIST ptr [esi]).head, ecx
@@:
	cmp eax, (LLIST ptr [esi]).tail
	jnz @F
	mov (LLIST ptr [esi]).tail, edx
@@:
	
	pop edi
	pop esi
	ret
	
llRemove endp

llIterateStart proc list:dword
	
	push sizeof LITERATE
	push LMEM_FIXED
	call LocalAlloc
	
	mov edx, list
	mov (LITERATE ptr [eax])._list, eax
	mov edx, (LLIST ptr [edx]).head
	mov (LITERATE ptr [eax]).next, edx
	
	ret
	
llIterateStart endp

llIterateNext proc literate:dword
	
	mov edx, literate
	mov eax, (LITERATE ptr [edx]).next
	test eax, eax
	jz @F
	
	mov ecx, (LNODE ptr [eax]).next
	mov (LITERATE ptr [edx]).next, ecx
	mov (LITERATE ptr [edx]).last, eax
	
@@:
	ret
	
llIterateNext endp

llIterateRemove proc literate:dword
	mov eax, literate
	push (LITERATE ptr [eax]).last
	push (LITERATE ptr [eax])._list
	call llRemove
	
	ret
llIterateRemove endp

llIterateEnd proc literate:dword
	
	push literate
	call LocalFree
	
	ret
	
llIterateEnd endp

llDestroy proc list:dword
	
	push esi
	push edi
	
	mov esi, list
	
	mov edx, (LLIST ptr [esi]).head
@@:
	mov edi, (LNODE ptr [edx]).next
	fsFree edx, %(sizeof LNODE)
	mov edx, edi
	test edi, edi
	jnz @B
	
	push esi
	call LocalFree
	
	pop edi
	pop esi
	ret
	
llDestroy endp